//
//  ViewController.swift
//  MQTT_Test
//
//  Created by duwt on 2023/9/7.
//

import UIKit
import Network
import CocoaMQTT

class ViewController: UIViewController {

    @IBOutlet weak var connectButton: UIButton!

    var clientId:String = "input your cliendId"

    let defaultHost = "inPut your mqtt domain"

    let port = xxxx

    let password = "xxxxx"

    //    let topic = "utrend/printer/1696344509114028034/server-call-app/v1"
    let topic2 = "xxxx"

    let topic1 = "xxxx"

    var mqtt5: CocoaMQTT5?

    var urlSession:URLSession?

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        self.cocoMqttSetting()
    }

    @IBAction func sendMsg(_ sender: Any) {
        mqtt5?.publish(topic1, withString: "test Message",qos: .qos1, properties: MqttPublishProperties())
    }
    
    @IBAction @objc private func connectAction( sender:UIButton) {
        mqttConnect()
    }

    @IBAction func topicAction(_ sender: Any) {
        mqtt5?.subscribe(topic2)
    }


    func cocoMqttSetting(){
        let websocket = CocoaMQTTWebSocket(uri: "/mqtt")
        mqtt5 = CocoaMQTT5(clientID: clientId, host: defaultHost, port: UInt16(port),socket: websocket)
        mqtt5?.logLevel = .debug
        mqtt5?.password = password
        mqtt5?.keepAlive = 60
        mqtt5?.delegate = self
        mqtt5?.autoReconnect = true
        mqtt5?.cleanSession  = true
        mqtt5?.delegateQueue = .global(qos:.utility)
        mqtt5?.backgroundOnSocket = true
        mqtt5?.enableSSL = true
        mqtt5?.allowUntrustCACertificate = true

        mqtt5?.didReceiveMessage = { mqtt, message, id,publishData in
            print("Message received in topic \(message.topic) with payload \(message.string!)")
        }

        let authProperties = MqttAuthProperties()
        mqtt5?.auth(reasonCode: CocoaMQTTAUTHReasonCode.continueAuthentication, authProperties: authProperties)
    }




    func mqttConnect(){
        let result = mqtt5?.connect()
        print(result == true ? "正在建立连接" : "连接失败")
    }

    func TRACE(_ message: String = "", fun: String = #function) {
        let names = fun.components(separatedBy: ":")
        var prettyName: String
        if names.count == 2 {
            prettyName = names[0]
        } else {
            prettyName = names[1]
        }

        if fun == "mqttDidDisconnect(_:withError:)" {
            prettyName = "didDisconnect"
        }
        print("[TRACE] [\(prettyName)]: \(message)")
    }
}

extension ViewController:CocoaMQTT5Delegate {
    func mqtt5(_ mqtt5: CocoaMQTT5, didReceiveMessage message: CocoaMQTT5Message, id: UInt16, publishData: MqttDecodePublish?) {
    }

    func mqtt5UrlSession(_ mqtt: CocoaMQTT5, didReceiveTrust trust: SecTrust, didReceiveChallenge challenge: URLAuthenticationChallenge, completionHandler: @escaping (URLSession.AuthChallengeDisposition, URLCredential?) -> Void) {
        if (challenge.protectionSpace.authenticationMethod == NSURLAuthenticationMethodServerTrust) {
            
            let url = Bundle.main.url(forResource: "bundle", withExtension: "der")!
            let certData = try! Data.init(contentsOf: url)
            if let trust = challenge.protectionSpace.serverTrust,
               let cert = SecCertificateCreateWithData(nil,  certData as CFData) {
                SecTrustSetAnchorCertificates(trust, [cert] as CFArray)
                completionHandler(URLSession.AuthChallengeDisposition.useCredential, URLCredential(trust: trust))
                return
            }
        }
        completionHandler(URLSession.AuthChallengeDisposition.cancelAuthenticationChallenge, nil)
    }

    func mqtt5(_ mqtt5: CocoaMQTT5, didReceiveDisconnectReasonCode reasonCode: CocoaMQTTDISCONNECTReasonCode) {
        print("disconnect res : \(reasonCode)")
    }

    func mqtt5(_ mqtt5: CocoaMQTT5, didReceiveAuthReasonCode reasonCode: CocoaMQTTAUTHReasonCode) {
        print("auth res : \(reasonCode)")
    }

    func mqtt5(_ mqtt5: CocoaMQTT5, didConnectAck ack: CocoaMQTTCONNACKReasonCode, connAckData: MqttDecodeConnAck?) {
        TRACE("ack: \(ack)")
        if ack == .success {
            if(connAckData != nil){
                print("properties maximumPacketSize: \(String(describing: connAckData!.maximumPacketSize))")
                print("properties topicAliasMaximum: \(String(describing: connAckData!.topicAliasMaximum))")
            }
        }
    }

    func mqtt5(_ mqtt5: CocoaMQTT5, didStateChangeTo state: CocoaMQTTConnState) {
        TRACE("new state: \(state)")
    }

    func mqtt5(_ mqtt5: CocoaMQTT5, didPublishMessage message: CocoaMQTT5Message, id: UInt16) {
        TRACE("message: \(message.description), id: \(id)")
    }

    func mqtt5(_ mqtt5: CocoaMQTT5, didPublishAck id: UInt16, pubAckData: MqttDecodePubAck?) {
        TRACE("id: \(id)")
        if(pubAckData != nil){
            print("pubAckData reasonCode: \(String(describing: pubAckData!.reasonCode))")
        }
    }

    func mqtt5(_ mqtt5: CocoaMQTT5, didPublishRec id: UInt16, pubRecData: MqttDecodePubRec?) {
        TRACE("id: \(id)")
        if(pubRecData != nil){
            print("pubRecData reasonCode: \(String(describing: pubRecData!.reasonCode))")
        }
    }

    func mqtt5(_ mqtt5: CocoaMQTT5, didPublishComplete id: UInt16,  pubCompData: MqttDecodePubComp?){
        TRACE("id: \(id)")
        if(pubCompData != nil){
            print("pubCompData reasonCode: \(String(describing: pubCompData!.reasonCode))")
        }
    }

    func mqtt5(_ mqtt5: CocoaMQTT5, didSubscribeTopics success: NSDictionary, failed: [String], subAckData: MqttDecodeSubAck?) {
        TRACE("subscribed: \(success), failed: \(failed)")
        if(subAckData != nil){
            print("subAckData.reasonCodes \(String(describing: subAckData!.reasonString))")
        }
    }

    func mqtt5(_ mqtt5: CocoaMQTT5, didUnsubscribeTopics topics: [String], unsubAckData: MqttDecodeUnsubAck?) {
        TRACE("topic: \(topics)")
        if(unsubAckData != nil){
            print("unsubAckData.reasonCodes \(String(describing: unsubAckData!.reasonCodes))")
        }
        print("----------------------")
    }

    func mqtt5DidPing(_ mqtt5: CocoaMQTT5) {
        TRACE("mqtt5DidPing")
    }

    func mqtt5DidReceivePong(_ mqtt5: CocoaMQTT5) {
        TRACE("mqtt5DidReceivePong")
    }

    func mqtt5DidDisconnect(_ mqtt5: CocoaMQTT5, withError err: Error?) {
        TRACE("\(err)")
    }
}
